/**  ClientApplet
 *     @autore     Luigi Antenucci
 *     @versione   2.0
 *     @linguaggio jdk 1.2
 */

import java.lang.Thread;
import java.net.Socket;
import java.io.InputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.util.Vector;
import java.applet.Applet;
import java.awt.Frame;
import java.io.IOException;
import java.io.InterruptedIOException;
import java.net.UnknownHostException;


public class ClientApplet extends Applet {
  /** Il programma (applet) CLIENT
   */

  // Costanti pubbliche:
  public static final byte DAMMI_SC  = 0;
  public static final byte DAMMI_PL  = 1;
  public static final byte DAMMI_SER = 2;
  public static final byte DAMMI_POME =3;

  // Costanti private
  protected static final String NOME_FILE_CFG = "CLIENT.CFG";  // File di configurazione

  // Variabile di classe: indirizzo del server
  public    static final byte MIN_NUM_SER = 0;
  public    static final byte MAX_NUM_SER = 2;       // INDIRIZZI DEI SERVER NOTI:
  protected static String[] IndServer = new String [MAX_NUM_SER+1];

  // Variabili pubbliche per definire la RITRASMISSIONE del CLIENT:
  public    static int  TIMEOUT_CLI   = 40000;  // TIME-OUT  (in millisecondi)
  public    static int  MAX_TENTA_CLI = 3;      // Massimo numero di ritrasmissioni

  // Uso il pattern Model-View-Control:
  // Il client usa un display che a sua volta usa il client
  protected ClientDisplay MyCliDisp;

  public boolean GigiRight  = true;          // Stampare finestra copyright a avvio?


  public ClientApplet () {
    // Crea l'applet con il suo display in una nuova finestra
    super();
    MyCliDisp = new ClientDisplay (this);
    Inizializza();
  } //ClientApplet

  public ClientApplet (Frame FinGiaCreata) {
    // Crea l'applet con il suo display nella finestra data
    super();
    MyCliDisp = new ClientDisplay (this, FinGiaCreata);
  } //ClientApplet


  protected void Inizializza () {
    for (byte i=MIN_NUM_SER; i<=MAX_NUM_SER; i++)
      IndServer[i] = new String ("");
    caricaConfig ();                  // All'avvio, carico la config. da disco (se c'e')
  } //Inizializza

  
  public void init () {
    // Inizializzazione dell'applet
    Inizializza();
    Debug.outln ("CLIENT --- lanciato");
  } //init


  public void start () {
    // Esecuzione dell'applet
    if (GigiRight)
      eseguiInfo();
  } //start


  public void stop () {
    salvaConfig ();            // Prima di uscire salvo la configurazione!
    Debug.distruggiFinestra();
    MyCliDisp.distruggiDisplay();
    super.stop();
    System.exit(0);
  } //stop


  public ClientDisplay rendiDisplay () {
    return MyCliDisp;
  } //rendiDisplay()


  public void apriDebug (boolean apri) {
    boolean esisteGia = Debug.esisteFinestra();
    if (apri)
      if (esisteGia)
        ;  // nulla
      else {
        Debug.creaFinestra();      // Crea, se check=T e non esiste
        Debug.riposiziona (0, 385);
      }
    else  // not apri -> chiudi
      if (esisteGia)
        Debug.distruggiFinestra(); // Toglie, se check=F e esiste
      else
        ; // nulla
  } //apriDebug


  public static void defIndirizzoServer (byte NumInd, String NuovoInd) {
    // Definisce l'indirizzo del server con cui comunicare
    if ((NumInd >= MIN_NUM_SER) && (NumInd <= MAX_NUM_SER))
      IndServer[NumInd] = NuovoInd;
  } //defIndirizzoServer


  public static String rendiIndirizzoServer (int NumInd) {
    // Definisce l'indirizzo del server con cui comunicare
    if ((NumInd >= MIN_NUM_SER) && (NumInd <= MAX_NUM_SER))
      return IndServer[NumInd];
    else
      return "";
  } //defIndirizzoServer


  public void eseguiInfo () {
    Frame FinGen = (Frame) MyCliDisp.rendiFinContenente();
    DisplayGigi MyD = new DisplayGigi (FinGen, "client");
  } //eseguiInfo


  public void eseguiPrenotaCancella (boolean FaiPrenota) {
    // CHIAMATA DAL LISTENER "PRENOTA" (FaiPrenota=true)
    // o da quello di "CANCELLA" (FaiPrenota=false)
    MessCli   Msg;
    String    Frase;
    Prenotazione NuovaPren;

    try {

      // Richiede la prenotazione al Display 
      try {
        NuovaPren = MyCliDisp.rendiPrenotazione();
      } 
      catch (Exception E) {
        String CheCosa = "";
        try {
          CheCosa = "DELLO SPETTACOLO";
          MyCliDisp.rendiSpettacolo();
          CheCosa = "DEL POSTO";
          MyCliDisp.rendiPosto();
          CheCosa = "";
        }
        catch (Exception E2) { }
        throw new Exception ("DATI "+CheCosa+" INSUFFICIENTI O ERRATI");
      }

      // Controllo che i dati siano "corretti".
      if (! NuovaPren.corretto())
        if (! NuovaPren.rendiSpettatore().corretto())
          throw new Exception ("DATI DELLO SPETTATORE ERRATI");
        else
          if (! NuovaPren.rendiSpettacolo().corretto())
            throw new Exception ("DATI DELLO SPETTACOLO ERRATI");
          else
            throw new Exception ("DATI DEL POSTO ERRATI");

    } 
    catch (Exception Err) {
      // Avvisa l'utente con una finestra di dialogo
      MyCliDisp.apriDialogoErrModale (Dialogo.BOTT_OK, 
                                      "ERRORE", Err.getMessage());
      return;  // Uscita dal metodo!
    } //catch

    // Crea il messaggio (del client) per il server e avvisa l'utente
    if (FaiPrenota) {
      Frase = new String ("PRENOTAZIONE");
      Msg = new MessCliRichiedi (NuovaPren);
    }
    else {
      Frase = new String ("CANCELLAZIONE");
      Msg = new MessCliCancella (NuovaPren);
    }
    Frase = Frase.concat (" IN CORSO...");

    Debug.outln ("CLIENT --- "+Frase);
    Debug.outln ("           "+NuovaPren);

    byte    Tenta = 0;            // Primo tentativo
    boolean Ok    = false;        // Non ho ricevuto i dati
    do {
      // Crea una finestra di dialogo con "attendere prego"
      Dialogo MyDialog = MyCliDisp.apriDialogoLibero (Dialogo.BOTT_nulla, 
                                              Frase, "ATTENDERE, PREGO");

      // Crea una connessione (stream) col server e invia il messaggio
      // Nota: tentativi successivi usano una socket sempre nuova
      Tenta++;
      Msg.defTentativo (Tenta);   // Inserisce il "tentativo" nel messaggio
      try {
        Debug.outln ("CLIENT --- tentativo N."+Tenta);
        Socket Sock = creaConnessione ();

        try {
          inviaMessaggio (Msg, Sock);

          try {

            Sock.setSoTimeout (TIMEOUT_CLI);         // ATTESA DEI DATI CON TIME-OUT!!!

            Debug.outln ("CLIENT --- attendendo la risposta via socket-stream, con time-out");
      
            MessCli MsgRisp = riceviMessaggio (Sock);  // ATTENDO QUI..

            if (! (MsgRisp instanceof MessCliInfo))
              throw new Exception ("MESSAGGIO DI RITORNO ERRATO");

            String Risp = ((MessCliInfo)MsgRisp).cheFrase();
            Ok = true;

            Debug.outln ("CLIENT --- Ricevuta la Risposta: "+Risp);
            MyCliDisp.apriDialogoModale (Dialogo.BOTT_OK, 
                         "Risposta del Server:", Risp);
            // Nota: mi fermo sul "dialogo" fino a pressione di "OK"
  
          }
          catch (InterruptedIOException EInt) {
            Debug.outln ("CLIENT --- TIME-OUT SCADUTO!");
            MyCliDisp.apriDialogoErrModale (Dialogo.BOTT_OK,
                                            "ERRORE di TIME-OUT:", "FUORI TEMPO MASSIMO");
          }
          catch (Exception Err) { 
            MyCliDisp.apriDialogoErrModale (Dialogo.BOTT_OK,
                              "ERRORE RICEVENDO I DATI", Err.getMessage());
          }
          finally {
            Sock.close();       // Chiudo la socket (in ogni caso)
          }
        } 
        catch (IOException Err) {
          MyCliDisp.apriDialogoErrModale (Dialogo.BOTT_OK, 
                              "ERRORE INVIANDO I DATI", Err.getMessage());
        }
      } 
      catch (Exception Err) { 
        MyCliDisp.apriDialogoErrModale (Dialogo.BOTT_OK, "ERRORE! IL SERVER NON ESISTE PIU`",
                                        "(Controlla gli Indirizzi in 'CONFIGURA')");
      } 
      finally {
        MyDialog.dispose();   // Rimuove la fin.di dialogo "attendere prego"
      }

    }
    while ((! Ok) &&                   // esce quando risposta arrivata o
           (Tenta < MAX_TENTA_CLI));   // si e' fatto il MAX dei tentativi

    // AUTOMATISMO: se ho solo un indirizzo di server, alla fine della prenotazione 
    // gli chiedo gli indirizzi di altri due server (se ci sono o no)
    if (IndServer[MIN_NUM_SER+1].equals(""))
      eseguiDammiSpettacPostoServer (DAMMI_SER);

  } //eseguiPrenotaCancella


  public void eseguiConfig () {
    // CHIAMATA DAL LISTENER "CONFIG"
    // Crea l'apposito display
    Frame FinGen = (Frame) MyCliDisp.rendiFinContenente ();
    ClientDispCfg MyCliDisp = new ClientDispCfg (this, "CONFIG", FinGen);
    // Il savlataggio della nuova configurazione e' fatto nel display di config.
  } //eseguiConfig


  public void eseguiDammiSpettacPostoServer (byte DammiChe) {
    // CHIAMATA DAI LISTENER;
    // Include TUTTE le funzionalita' dei messaggi "MessCliDammi" 
    // DammiChe puo' contenere un valore "DAMMI_xxx" (vedi costanti)
    String   StrCosa = "";
    MessCliDammi Msg;

    // Crea il messaggio (del client) per il server e avvisa l'utente
    switch (DammiChe) {
      case DAMMI_SC : { Msg = new MessCliDammiSc ();
                        StrCosa = "Spettacoli";
                        break;
                      }
      case DAMMI_PL : { try {
                          Spettacolo Sc = MyCliDisp.rendiSpettacolo();
                          if (! Sc.corretto()) 
                            throw new Exception ("ERRORE");
                          Msg = new MessCliDammiPL (Sc);
                          StrCosa = "Posti Liberi per "+Sc.toString();
                        } 
                        catch (Exception E) { 
                          MyCliDisp.apriDialogoErrModale (Dialogo.BOTT_OK, "ERRORE!", 
                                                "PRIMA DEVI SCEGLIERE UNO SPETTACOLO");
                          return; // EXIT!
                        }
                        break;
                      }
      case DAMMI_SER: { Msg = new MessCliDammi2Ser ();
                        StrCosa = "Altri Indirizzi di Server";
                        break;
                      }
      case DAMMI_POME:{ try {
                          Spettatore St = MyCliDisp.rendiSpettatore();
                          if (! St.corretto()) 
                            throw new Exception ("ERRORE");
                          try {
                            Spettacolo Sc = MyCliDisp.rendiSpettacolo();
                            if (! Sc.corretto()) 
                              throw new Exception ("ERRORE");
                            Msg = new MessCliDammiPOMe (Sc, St);
                            StrCosa = "Posti di "+St.toString()+" In "+Sc.toString();
                          }
                          catch (Exception E) { 
                            MyCliDisp.apriDialogoErrModale (Dialogo.BOTT_OK, "ERRORE!", 
                                                    "PRIMA DEVI SCEGLIERE UNO SPETTACOLO");
                            return; // EXIT!
                          }
                        }
                        catch (Exception E) { 
                          MyCliDisp.apriDialogoErrModale (Dialogo.BOTT_OK, "ERRORE!", 
                                                    "PRIMA DEVI INSERIRE I DATI DELLO SPETTATORE");
                          return; // EXIT!
                        }
                        break;
                      }
      default       : return;
    } //switch

    byte    Tenta = 0;        // Primo tentativo
    boolean Ok    = false;    // Non ho ricevuto i dati
    do {
      // Crea una finestra di dialogo con "attendere prego"
      Debug.outln ("CLIENT --- richiedendo "+StrCosa);
      Dialogo MyDialog = MyCliDisp.apriDialogoLibero (Dialogo.BOTT_nulla, 
                 "Richiesta "+StrCosa+" in Corso...", "ATTENDERE, PREGO");

      // Crea una connessione (stream) col server e invia il messaggio
      // Nota: tentativi successivi usano una socket sempre nuova
      Tenta++;
      Msg.defTentativo (Tenta);   // Inserisce il "tentativo" nel messaggio
      try {
        Socket Sock = creaConnessione ();

        try {
          inviaMessaggio (Msg, Sock);

          try {

            Sock.setSoTimeout (TIMEOUT_CLI);         // ATTESA DEI DATI CON TIME-OUT!!!

            switch (DammiChe) {
              case DAMMI_SC  : 
              case DAMMI_PL  :
              case DAMMI_POME:    // in questi due casi uso il late-binding sulla lista
                   {
                      // Legge dal server l'intero vettore usando la "serializzazione"
                      // dell'oggetto "Vector" (che implementa "Serializable")
                      Debug.outln ("CLIENT --- attendendo l'oggetto elenco via socket-stream, con time-out");

                      ObjectInputStream MyIn = new ObjectInputStream (Sock.getInputStream());
                      Vector ElencoSc = (Vector) MyIn.readObject ();
                      Ok = true;  // Ho letto i dati

                      Debug.outln ("CLIENT --- ricezione elenco completata");
                      // Stampa con AWT e scelta spettacolo.
                      Frame FinGen = (Frame) MyCliDisp.rendiFinContenente ();
                      byte UsoChe;
                      switch (DammiChe) {
                        case DAMMI_SC:   { UsoChe = ClientDispLista.USO_ELENCO_SC;   break; }
                        case DAMMI_PL:   { UsoChe = ClientDispLista.USO_ELENCO_PL;   break; }
                        case DAMMI_POME: { UsoChe = ClientDispLista.USO_ELENCO_POME; break; }
                        default        :   UsoChe = -1;
                      }
                      if (UsoChe >= 0) {
                        // BUG DI JDK 1.2.1: SE QUI NON SI METTE IL BEGIN-END SI AVRA'
                        //  UN "Invalid Declaration" sull'istruzione sottostante
                        ClientDispLista Disp = new ClientDispLista (this, ElencoSc, UsoChe,
                                                                    "SCELTA "+StrCosa, FinGen);
                      }
                      else
                        Debug.outln ("CLIENT --- non so come visualizzare la lista");
                      break;
                   }
              case DAMMI_SER:
                   {  Debug.outln ("CLIENT --- attendendo le stringhe via socket-stream, con time-out");

                      DataInputStream DIS = new DataInputStream (Sock.getInputStream());
                      byte N = DIS.readByte();  // Leggo in N. di stringhe in arrivo
                      String Letta;
                      Debug.outln ("CLIENT --- leggendo "+N+" stringhe:");

                      byte i = 0;
                      // PS: l'indirizzo 0 e' quello a cui ho fatto la richiesta;
                      //     gli indirizzi 1 e 2 saranno letti dal server;
                      while ((i < N) && (i < MAX_NUM_SER)) {
                        Letta = DIS.readUTF();   // Legge una stringa
                        Debug.outln ("           letta: '"+Letta+"'");
                        IndServer[++i] = Letta;
                      }
                      while (i < N) {
                        Letta = DIS.readUTF();   // Legge le eventuali stringhe rimaste
                        Debug.outln ("        ignorata: '"+Letta+"'");
                        i++;
                      }
                      Ok = true;  // Ho letto i dati
                      break;
                   }
            } //switch
          }
          catch (InterruptedIOException EInt) {
            Debug.outln ("CLIENT --- TIME-OUT SCADUTO!");
            MyCliDisp.apriDialogoErrModale (Dialogo.BOTT_OK,
                                            "ERRORE di TIME-OUT:", "FUORI TEMPO MASSIMO");
          }
          catch (Exception Err) {
            MyCliDisp.apriDialogoErrModale (Dialogo.BOTT_OK, "ERRORE!", 
                                            "ERRORE RICEVENDO I DATI");
          }
        }
        catch (IOException Err) {
          MyCliDisp.apriDialogoErrModale (Dialogo.BOTT_OK, "ERRORE!", 
                                          "ERRORE INVIANDO I DATI");
        }
        finally {
          Sock.close();       // Chiudo la socket (in ogni caso)
        }
      }
      catch (Exception Err) { 
        MyCliDisp.apriDialogoErrModale (Dialogo.BOTT_OK, "ERRORE! IL SERVER NON ESISTE PIU`",
                                        "(Controlla gli Indirizzi in 'CONFIGURA')");
      }
      finally {
        MyDialog.dispose();   // Rimuove la fin.di dialogo "attendere prego"
      }

    }
    while ((! Ok) &&                   // esce quando risposta arrivata o
           (Tenta < MAX_TENTA_CLI));   // si e' fatto il MAX dei tentativi

  } //eseguiDammiSpettacPostoServer


  public void eseguiTermina () {
    // Chiede CONFERMA a utente prima di chiudere
    int PremutoChe = MyCliDisp.apriDialogoModale (Dialogo.BOTT_SINO, 
                                       "Sei Sicuro di Voler Uscire?", "");
    if (PremutoChe == Dialogo.PREMUTO_SI)
      stop();
  } //eseguiTermina


  protected Socket creaConnessione () throws Exception {
    // Crea una connessione socket-stream col server
    // Prova tutti i server noti, se una connessione non funziona
    String ERR_NOSERVER = "Tutti i Server NON Sono Disponibili";
    Socket NewSock;
    byte   NumSer = MIN_NUM_SER;  // Usa il primo server

    while (true) {   // Esco con "return" o "throw"

      try {         // Prova a creare una connessione

        if (IndServer[NumSer].equals(""))
          throw new Exception ("L'INDIRIZZO NON E' STATO DEFINITO");

        Debug.outln ("CLIENT --- connettendosi al server N."+NumSer+" "+IndServer[NumSer]);
        NewSock = new Socket (IndServer[NumSer], Comune.PORTA_STREAM_CLI);
        
        return NewSock;  // Se tutto ok, la rende

      } 
      catch (Exception E) {
        Errore (E);  
        // NON C'E' IL SERVER: PROVO CON UN ALTRO!
        if (NumSer < MAX_NUM_SER) {
          NumSer++;
          if (IndServer[NumSer] == null)
            throw new Exception (ERR_NOSERVER);
          else
            if (IndServer[NumSer].equals(""))
              throw new Exception (ERR_NOSERVER);
        }
        else //NumSer=MAX_NUM_SER
          throw new Exception (ERR_NOSERVER);
      } //catch
    } //while
     
  } //creaConnessione

 
  protected Socket creaConnessioneConSer (byte NumSer) throws Exception {
    // Crea una connessione solo col numero di server specificato
    return new Socket (IndServer[NumSer], Comune.PORTA_STREAM_CLI);
  } //creaConnessioneConSer


  protected void inviaMessaggio (MessCli MyMess, Socket MySock) throws IOException {
    DataOutputStream MyOutput = null;

    // Invia la richiesta
    Debug.outln ("CLIENT --- Inviando il messaggio "+MyMess.toString());
    try {
      MyOutput = new DataOutputStream (MySock.getOutputStream());
      TraslaMess.scriviMess (MyMess, MyOutput);
      MyOutput.flush();
    } 
    catch (IOException Err) { Errore(Err); }
    // NON FARE "MyOutput.close()" se no chiudo anche la socket!
  } //inviaMessaggio


  protected MessCli riceviMessaggio (Socket MySock) throws IOException {
    // Acquisisce il flusso di input dalla socket
    DataInputStream  MyInput = new DataInputStream (MySock.getInputStream());

    // Cerca di leggere il messaggio 
    return (MessCli) TraslaMess.creaMess (MyInput);
  } //riceviMessaggio


  public void salvaConfig () {
    // Salva su disco i dati di configurazione
    try {
      FileOutputStream FOS = new FileOutputStream (NOME_FILE_CFG);
      DataOutputStream DOS = new DataOutputStream (FOS);
      Debug.outln ("CLIENT --- salvando la configurazione su disco");

      for (byte i=MIN_NUM_SER; i<=MAX_NUM_SER; i++)
        DOS.writeUTF  (IndServer[i]);
      DOS.writeInt (TIMEOUT_CLI);
      DOS.writeInt (MAX_TENTA_CLI);
      DOS.writeBoolean (Debug.esisteFinestra());
      DOS.writeBoolean (GigiRight);
      
      FOS.close();
    }
    catch (Exception Err) { }  // nulla
  } //salvaConfig


  public void caricaConfig () {
    // Carica da disco i dati di configurazione (se sono stati salvati)
    try {
      FileInputStream FIS = new FileInputStream (NOME_FILE_CFG);
      DataInputStream DIS = new DataInputStream (FIS);
      Debug.outln ("CLIENT --- caricando la configurazione da disco");

      for (byte i=MIN_NUM_SER; i<=MAX_NUM_SER; i++)
        IndServer[i] = DIS.readUTF();
      TIMEOUT_CLI   = DIS.readInt ();
      MAX_TENTA_CLI = DIS.readInt ();
      apriDebug (DIS.readBoolean());
      GigiRight     = DIS.readBoolean ();

      FIS.close();
    }
    catch (Exception Err) { }  // nulla
  } //caricaConfig


  protected void Errore (Exception Err) {
    Debug.outln ("CLIENT --- ERRORE: "+Err);
  } //Errore

} //ClientApplet