/**  Dato (interfaccia comune a spettatore, spettacolo, posto e prenotazione)
 *     @autore     Luigi Antenucci
 *     @versione   2.0
 *     @linguaggio jdk 1.2
 */

import java.io.DataOutputStream;
import java.io.IOException;


interface Dato {
  /** Astrazione usata per elencare i metodi che devono implementare tutti
   *  i dati di "utente", ossia: spettatore, spettacolo, posto e prenotazione.
   */

  // Devo avere due costruttori per costruire l'oggetto avendo in ingresso:
  // - i dati semplici (interi e stringhe)
  // - un "DataInputStream"

  public void scriviInStream (DataOutputStream DOS) throws IOException;

  // Devo avere dei metodi "rendiXXX" che rendono i dati semplici che
  // compongono l'oggetto (quelli passati al primo costruttore)

  public boolean corretto ();
  // Per sapere se i dati contenuti sono corretti

  public String toString();
  // Overriding del metodo definito in "Object" per rappresentazione in stringa

  public boolean equals (Object obj);
  public int hashCode();
  // Overriding dei metodi definiti in "Object" per fare la ricerca nella Hashtable

} //Dato