/**  DatoZona (interfaccia comune alle "Zone" per spettatore, spettacolo, posto)
 *     @autore     Luigi Antenucci
 *     @versione   2.0
 *     @linguaggio jdk 1.2
 */

import java.awt.Color;
import java.awt.Font;
import java.lang.Exception;


interface DatoZona {
  /** Astrazione usata per elencare i metodi che devono implementare tutte le
   *  "zone" di dati di "utente", ossia: spettatore, spettacolo, posto.
   */

  // Costanti per i colori di default da usare:
  public static final Color COL_SFO       = Color.blue;      // Finestra
  public static final Color COL_TXT_NOME  = Color.yellow;
  public static final Color COL_TXT_CAMPO = Color.white;

  // Costanti per i tipi di font usati:
  public static final Font  FONT_NOME  = new Font 
                                         ("Serif",  Font.BOLD|Font.ITALIC, 20);
  public static final Font  FONT_CAMPO = new Font 
                                         ("Serif",       Font.PLAIN,       18);
  public static final Font  FONT_INPUT = new Font
                                         ("DialogInput", Font.BOLD,        18);
  // in Java 1.2 uso "Serif"       anziche' "TimesRoman"
  //                 "DialogInput" anziche' "Courier"

  
  public Object rendiDati() throws Exception;

  public void riempiDati (Object DatiNuovi);

  public void cancella ();

} //DatoZona