/**  Debug
 *     @autore     Luigi Antenucci
 *     @versione   1.0
 *     @linguaggio jdk 1.2
 */

import java.awt.Frame;
import java.awt.TextArea;
import java.awt.Color;
import java.awt.Font;
import java.awt.Cursor;
import java.awt.BorderLayout;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowListener;
import java.awt.event.WindowEvent;


class ListenKillDebug implements WindowListener {
  // Il listener per la finestra di debug

  public ListenKillDebug () { 
  } //costruttore

  public void windowClosed      (WindowEvent evt) { }
  public void windowDeiconified (WindowEvent evt) { }
  public void windowIconified   (WindowEvent evt) { }
  public void windowActivated   (WindowEvent evt) { }
  public void windowDeactivated (WindowEvent evt) { }
  public void windowOpened      (WindowEvent evt) { }

  public void windowClosing     (WindowEvent evt) {
    Debug.distruggiFinestra();
  } //windowClosing

} //ListenKillDebug


class ListenCanDebug implements ActionListener {

  public ListenCanDebug () {
  } //costruttore

  public void actionPerformed (ActionEvent evt) {
    Debug.svuotaFinestra();
  } //actionPerformed

} //ListenCanDebug


public class Debug {
  /** Serve per stampare messaggi di debug in un'unica finestra.
   *  E' UN OGGETTO TOTALMENTE STATICO (tutti attributi e metodi "static").
   */

  // Costanti per i colori:
  protected static final Color COL_CAR  = Color.green;
  protected static final Color COL_SFO  = Color.black;
  protected static final Color BCOL_CAR = Color.yellow;
  protected static final Color BCOL_SFO = Color.blue;


  // Variabili di classe per mantenere la finestra su cui scrivere
  protected static Finestra DebugWin = null;
  protected static TextArea Testo;


  public static void creaFinestra () {
    creaFinestra (0, 360);
  } //creaFinestra

  public static void creaFinestra (int PosX, int PosY) {
    if (DebugWin == null) {
      DebugWin = new Finestra ("*** FINESTRA DI DEBUG ***");
      DebugWin.setLayout(new BorderLayout());

      Bottone BottCanc = new Bottone ("PULISCI", BCOL_SFO, BCOL_CAR, 
                                      new Font("DialogInput", Font.BOLD, 16) );
      BottCanc.addActionListener (new ListenCanDebug());
      DebugWin.add (BottCanc, "North");

      Testo = new TextArea ("Avvio..\n", 12, 70);
      Testo.setBackground (COL_SFO);
      Testo.setForeground (COL_CAR);
      Testo.setFont (new Font("Courier", Font.PLAIN, 12));
      Testo.setEditable (false);
      DebugWin.add (Testo, "Center");

      DebugWin.setCursor (new Cursor (Cursor.HAND_CURSOR));

      DebugWin.addWindowListener (new ListenKillDebug());   // ne ascolta gli eventi

      DebugWin.setLocation (PosX, PosY);
      DebugWin.pack();
      DebugWin.setVisible (true);  // mostra la finestra
    }
  } //creaFinestra


  public static void distruggiFinestra () {
    if (DebugWin != null) {
      DebugWin.setVisible (false);
      DebugWin.dispose();
      DebugWin = null;
    }
  } //distruggiFinestra


  public static void svuotaFinestra () {
    if (DebugWin != null)
      Testo.setText("");
  } //svuotaFinestra


  public static boolean esisteFinestra () {
    return DebugWin != null;
  } //esisteFinestra


  public static void riposiziona (int x, int y) {
    if (DebugWin != null)
      DebugWin.setLocation (x, y);
      DebugWin.repaint();
  } //riposiziona


  public static void ridimensiona (int lar, int alt) {
    if (DebugWin != null)
      DebugWin.setSize (lar, alt);
      DebugWin.repaint();
  } //ridimensiona


  public static synchronized void out (String mess) {
    if (DebugWin != null) 
      Testo.append (mess);
  } //out


  public static synchronized void outln (String mess) {
    if (DebugWin != null) 
      Testo.append (mess+"\n");
  } //outln

} //Debug