/**  DisplayGigi - display di info sull'autore
 *     @autore     Luigi Antenucci
 *     @versione   2.0
 *     @linguaggio jdk 1.2
 */

import java.awt.Frame;
import java.awt.Dialog;
import java.awt.Label;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Font;
import java.awt.Color;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;


//-------------- I "LISTENER" DEI BOTTONI ---------------------------------------------------------

class ListenGiGi implements ActionListener {
  // Astrazione di un listener che usa un'applicazione Server e
  // la finestra di configurazione (da distruggere)
  protected DisplayGigi FinGG;   // Finestra coi dati

  public ListenGiGi (DisplayGigi FinGG) { 
    this.FinGG  = FinGG;
  } //costruttore

  public void actionPerformed (ActionEvent evt) {
    // Non modifica i dati del Server
    FinGG.distruggiDisplay ();
  } //actionPerformed

} //ListenGiGi


//============== IL DISPLAY DI COPYRIGHT ==========================================================

class DisplayGigi extends Display {
  /** Il display con le info su Gigi (l'autore)
   */

  protected static Color COL_SFO_FIN  = Color.green;     // Finestra
  protected static Color COL_TXT_FIN  = Color.black;

  protected static Color COL_TXT_INFO = Color.blue;      // testo info

  protected static Color DCOL_SFO_BCP = Color.yellow;    // bottone
  protected static Color DCOL_CAR_BCP = Color.red;

  protected static Font  FONT_TEATRO  = new Font ("Sans",   Font.BOLD, 30);
  protected static Font  FONT_GIGI    = new Font ("Dialog", Font.BOLD, 24);
  protected static Font  FONT_INFO    = new Font ("Serif",  Font.BOLD, 20);

  protected String StrLatoCS;


  public DisplayGigi (Frame FinPapa, String StrLatoCS) {
    super ("CREATORE", FinPapa);
    this.StrLatoCS = StrLatoCS;
    CostruisciDisplay ();
    FineCostrDisplay ();
  } //costruttore


  protected void CostruisciDisplay () {
    super.CostruisciDisplay ();
    setBackground (COL_SFO_FIN);
    setForeground (COL_TXT_FIN);

    GridBagLayout      GBL = new GridBagLayout (); 
    GridBagConstraints GBC = new GridBagConstraints ();
    setLayout(GBL);

    GBC.anchor = GridBagConstraints.WEST;
    Label LT = new Label ("<< TEATRO >>");
    LT.setFont(FONT_TEATRO);
    GBC.gridx = 2;  GBC.gridy = 1;
    GBL.setConstraints (LT, GBC);
    add (LT);

    GBC.anchor = GridBagConstraints.EAST;
    Label LI1 = new Label ("Creato da");
    GBC.gridx = 1;  GBC.gridy = 5;
    GBL.setConstraints (LI1, GBC);
    add (LI1);

    Label LI2 = new Label ("Nel");
    GBC.gridx = 1;  GBC.gridy = 7;
    GBL.setConstraints (LI2, GBC);
    add (LI2);

    Label LI3 = new Label ("Per");
    GBC.gridx = 1;  GBC.gridy = 10;
    GBL.setConstraints (LI3, GBC);
    add (LI3);

    Label LXX = new Label ("Lato");
    GBC.gridx = 1;  GBC.gridy = 20;
    GBL.setConstraints (LXX, GBC);
    add (LXX);

    GBC.anchor = GridBagConstraints.WEST;
    Label LGG = new Label ("Luigi Antenucci");
    LGG.setFont(FONT_GIGI);
    LGG.setForeground (COL_TXT_INFO);
    GBC.gridx = 2;  GBC.gridy = 5;
    GBL.setConstraints (LGG, GBC);
    add (LGG);

    Label LG2 = new Label ("maggio-luglio 1999");
    LG2.setFont(FONT_INFO);
    LG2.setForeground (COL_TXT_INFO);
    GBC.gridx = 2;  GBC.gridy = 7;
    GBL.setConstraints (LG2, GBC);
    add (LG2);

    Label LG3 = new Label ("Reti di Calcolatori &");
    LG3.setFont(FONT_INFO);
    LG3.setForeground (COL_TXT_INFO);
    GBC.gridx = 2;  GBC.gridy = 10;
    GBL.setConstraints (LG3, GBC);
    add (LG3);
    Label LG3B = new Label ("Ingegneria del Software");
    LG3B.setFont(FONT_INFO);
    LG3B.setForeground (COL_TXT_INFO);
    GBC.gridx = 2;  GBC.gridy = 11;
    GBL.setConstraints (LG3B, GBC);
    add (LG3B);

    Label LXY = new Label (StrLatoCS);
    LXY.setFont(FONT_INFO);
    LXY.setForeground (COL_TXT_INFO);
    GBC.gridx = 2;  GBC.gridy = 20;
    GBL.setConstraints (LXY, GBC);
    add (LXY);

    GBC.anchor = GridBagConstraints.WEST;
    Bottone.defFont (FONT_BOTT);
    Bottone BottOk = new Bottone ("HO CAPITO", DCOL_SFO_BCP, DCOL_CAR_BCP);
    BottOk.addActionListener (new ListenGiGi (this));
    GBC.gridx = 2;  GBC.gridy = 22;
    GBL.setConstraints (BottOk, GBC);
    add (BottOk);

    riposiziona (150, 180);

    Dialog MyDialog = (Dialog) rendiFinContenente();
    MyDialog.setResizable(false);
    // MyDialog.toFront();

  } //CostruisciDisplay

} //DisplayGigi