/**  MessCli (figlia di Mess) da cui discendono i MessCliXxx
 *     @autore     Luigi Antenucci
 *     @versione   2.0
 *     @linguaggio jdk 1.2
 */

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;


abstract class MessCli extends Mess {
  /** Astrazione dei messaggi CLI<==>SER.
   *  Serve solo per avere l'astrazione di tutti i messaggi che
   *  possono essere scambiati tra client e server:  
   */
  public static final byte TENTA_INI = 1;

  protected byte  Tentativo;    // Numero di tentativo

  
  public MessCli () {
    Tentativo = TENTA_INI;
  } //costruttore

  public MessCli (byte Tentativo) {
    this.Tentativo = Tentativo;
  } //costruttore

  public MessCli (DataInputStream DIS) throws IOException {
    Tentativo = DIS.readByte ();
  } //costruttore


  public void scriviInStream (DataOutputStream DOS) throws IOException {
    DOS.writeByte (Tentativo);
  } //scriviInStream


  public byte cheTentativo () {
    return Tentativo;
  } //cheTentativo

  public void defTentativo (byte NuovoTentativo) { 
    Tentativo = NuovoTentativo;
  } //defTentativo

  public void incrementaTentativo () {
    if (Tentativo < Byte.MAX_VALUE)
      Tentativo++;
  } //incrementaTentativo


  public String toString () {
    return new String (getClass().getName()+"<>");
  } //toString


} //MessCli