/**  MessCliDammiPL (discendente di MessCliDammi)
 *     @autore     Luigi Antenucci
 *     @versione   2.0
 *     @linguaggio jdk 1.2
 */

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;


class MessCliDammiPL extends MessCliDammi {
  /** Messaggio Cli-->Ser per la richiesta di tutti
   *  i posti occupati per un certo spettacolo.
   */ 
   
  // Variabili d'istanza:
  protected Spettacolo Spettac;  // Contiene lo spettacolo


  public MessCliDammiPL (Spettacolo Spettac) {
    super();
    this.Spettac = Spettac;
  } //costruttore

  public MessCliDammiPL (Spettacolo Spettac, byte Tentativo) {
    super (Tentativo);
    this.Spettac = Spettac;
  } //costruttore

  public MessCliDammiPL (DataInputStream DIS) throws IOException {
    // costruisce il messaggio leggendo i dati da uno stream di dati
    super(DIS);
    Spettac = new Spettacolo (DIS);  // leggo spettacolo da DIS
  } //costruttore
  

  public void scriviInStream (DataOutputStream DOS) throws IOException {
    // scrive su uno stream di dati il messaggio
    super.scriviInStream(DOS);
    Spettac.scriviInStream(DOS);
  } //scriviInStream


  public Spettacolo cheSpettac () {
    return Spettac;
  } //cheSpettac


  public String toString () {
    return new String (getClass().getName()+"(Spettacolo="+Spettac+")");
  } //toString

} //MessCliDammiPL