/**  MessCliRichiedi (discendente di MessCli)
 *     @autore     Luigi Antenucci
 *     @versione   2.0
 *     @linguaggio jdk 1.2
 */

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;


class MessCliRichiedi extends MessCli {
  /** Messaggio Cli-->Ser per la richiesta di fare una prenotazione.
   */ 

  // Variabili d'istanza:
  protected Prenotazione Prenotaz;   // Contiene la prenotazione


  public MessCliRichiedi (Prenotazione Prenot) {
    super();
    Prenotaz = Prenot;
  } //costruttore

  public MessCliRichiedi (Prenotazione Prenot, byte Tentativo) {
    super(Tentativo);
    Prenotaz = Prenot;
  } //costruttore

  public MessCliRichiedi (DataInputStream DIS) throws IOException {
    // costruisce il messaggio leggendo i dati da uno stream di dati
    super(DIS);
    Prenotaz = new Prenotazione (DIS);  // leggo prenotazione da DIS
  } //costruttore


  public void scriviInStream (DataOutputStream DOS) throws IOException {
    // scrive su uno stream di dati il messaggio
    super.scriviInStream(DOS);
    Prenotaz.scriviInStream (DOS);
  } //scriviInStream


  public Prenotazione chePrenotaz () {
    return Prenotaz;
  } //chePrenotaz


  public String toString () {
    return new String (getClass().getName()+"(Tentat="+Tentativo+
                                            ",Prenotaz=["+Prenotaz+"])");
  } //toString

} //MessCliRichiedi