/**  MessSer (figlia di Mess) da cui discendono i MessSerXxx
 *     @autore     Luigi Antenucci
 *     @versione   2.0
 *     @linguaggio jdk 1.2
 */

import java.io.DataOutputStream;
import java.io.IOException;


abstract class MessSer extends Mess {
  /** Astrazione dei messaggi SER<==>SER.
   *  Serve per realizzare l'astrazione di tutti i messaggi
   *  che possono essere scambiati tra server e server.
   *  Da questa classe erediteranno tutti i messaggi scambiabili da server
   *  a server sull'anello (MessSerDg) o via connessione diretta (MessSerSs).
   */

  // Costanti usabili per inizializzare un messaggio
  public static final byte AVANTI   = 0;    // costanti per direzione 
  public static final byte INDIETRO = 1;

  public static final String[] NOME_DIR = {"AVANTI","INDIETRO"};


  public abstract void scriviInStream (DataOutputStream DOS) throws IOException;
    // Voglio che tutti i messaggi siano scrivibili in uno stream di dati

    // Occorre aggiungere un costruttore che crea un messaggio leggendo 
    // i dati da uno stream di dati (DataInputStream)


  public static byte cambiaDirez (byte Dir) { 
    if (Dir == AVANTI)
      return INDIETRO;
    else 
      return AVANTI;
  } //cambiaDirez


  public static String direzInStr (byte Dir) {
    return NOME_DIR[Dir];
  } //direzInStr

  public String toString () {
    return new String (getClass().getName()+"<>");
  } //toString

} //MessSer