/**  MessSerBlocca (discendente di MessSer)
 *     @autore     Luigi Antenucci
 *     @versione   2.0
 *     @linguaggio jdk 1.2
 */

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;


class MessSerBlocca extends MessSer {
  /** Messaggio Ser-->Ser per inviare un ordine di bloccare
   *  tutte le transazioni in una certa direzione.
   */

  // Variabili d'istanza:
  protected byte DirezBloc; // Direzione da bloccare


  public MessSerBlocca (byte DirDaBloc) {
    DirezBloc = DirDaBloc;
  } //costruttore

  public MessSerBlocca (DataInputStream DIS) throws IOException {
    DirezBloc = DIS.readByte ();
  } //costruttore


  public void scriviInStream (DataOutputStream DOS) throws IOException {
    DOS.writeByte (DirezBloc);
  } //scriviInStream


  public byte cheDirUsare () {
    return DirezBloc;
  } //cheDirUsare


  public String toString () {
    return new String (getClass().getName()+"(Dir="+MessSer.NOME_DIR[DirezBloc]+")");
  } //toString

} //MessSerBlocca