/**  MessSerCambSer (discendente di MessSer)
 *     @autore     Luigi Antenucci
 *     @versione   2.0
 *     @linguaggio jdk 1.2
 */

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;


class MessSerCambSer extends MessSer {
  /** Messaggio Ser-->Ser per inviare un ordine di cambiare il
   *  proprio server "vicino" (in avanti o indietro)
   */

  // Variabili d'istanza:
  protected byte     DirezCamb;  // Direzione server da cambiare
  protected Macchina NuovaMak;


  public MessSerCambSer (byte DirDaCamb, Macchina NuovaMakSer) {
    DirezCamb = DirDaCamb;
    NuovaMak  = NuovaMakSer;
  } //costruttore

  public MessSerCambSer (DataInputStream DIS) throws IOException {
    DirezCamb = DIS.readByte();
    NuovaMak  = new Macchina (DIS);
  } //costruttore


  public void scriviInStream (DataOutputStream DOS) throws IOException {
    DOS.writeByte (DirezCamb);
    NuovaMak.scriviInStream (DOS);
  } //scriviInStream


  public byte cheDirCambiare () {
    return DirezCamb;
  } //cheDirCambiare
  
  
  public Macchina cheNuovaMak () {
    return NuovaMak;
  } //cheNuovaMak


  public String toString () {
    return new String (getClass().getName()+"(DirezCamb="+MessSer.NOME_DIR[DirezCamb]+
                                            ",NuovaMak="+NuovaMak+")");
  } //toString

} //MessSerCambSer