/**  MessSerDgAggSc (discendente di MessSerDg)
 *     @autore     Luigi Antenucci
 *     @versione   2.0
 *     @linguaggio jdk 1.2
 */

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;


class MessSerDgAggSc extends MessSerDg {
  /** Messaggio Ser-->Ser su anello per inviare un ordine di aggiungere uno spettacolo.
   */

  // Variabili d'istanza:
  protected Spettacolo Spettac;


  public MessSerDgAggSc (Spettacolo Spettac) {
    super(AVANTI);         // Nota: in Avanti!
    this.Spettac = Spettac;
  } //costruttore

  public MessSerDgAggSc (DataInputStream DIS) throws IOException {
    super(DIS);
    Spettac = new Spettacolo(DIS);  // leggo spettacolo da DIS
  } //costruttore


  public void scriviInStream (DataOutputStream DOS) throws IOException {
    super.scriviInStream(DOS);
    Spettac.scriviInStream (DOS);
  } //scriviInStream


  public Spettacolo cheSpettacolo () {
    return Spettac;
  } //cheSpettacolo


  public String toString () {
    return new String (getClass().getName()+
                       "(Dir="+MessSer.NOME_DIR[Direz]+",Vita="+Vita+",Mak="+Mak+
                       ",Spettac=["+Spettac+"])");
  } //toString

} //MessSerDgAggSc