/**  MessSerDgPrenota (discendente di MessSerDg)
 *     @autore     Luigi Antenucci
 *     @versione   2.0
 *     @linguaggio jdk 1.2
 */

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;


class MessSerDgPrenota extends MessSerDg {
  /** Messaggio Ser-->Ser su anello per inviare un ordine di prenotazione.
   */

  // Variabili d'istanza:
  protected Prenotazione Prenotaz;


  public MessSerDgPrenota (Prenotazione Prenot) {
    super(AVANTI);         // Nota: in Avanti!
    Prenotaz = Prenot;
  } //costruttore

  public MessSerDgPrenota (DataInputStream DIS) throws IOException {
    super(DIS);
    Prenotaz = new Prenotazione(DIS);  // leggo prenotazione da DIS
  } //costruttore


  public void scriviInStream (DataOutputStream DOS) throws IOException {
    super.scriviInStream(DOS);
    Prenotaz.scriviInStream (DOS);
  } //scriviInStream


  public Prenotazione chePrenotaz () {
    return Prenotaz;
  } //chePrenotaz


  public String toString () {
    return new String (getClass().getName()+
                       "(Dir="+MessSer.NOME_DIR[Direz]+",Vita="+Vita+",Mak="+Mak+
                       ",Prenotaz=["+Prenotaz+"])");
  } //toString

} //MessSerDgPrenota