/**  MessSerPassami (discendente di MessSer)
 *     @autore     Luigi Antenucci
 *     @versione   2.0
 *     @linguaggio jdk 1.2
 */

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;


class MessSerPassami extends MessSer {
  /** Messaggio Ser-->Ser per controllare se il server successore  vivo
   *  oppure no;  un messaggio da far passare in avanti
   */

  // Variabili d'istanza:
  protected Macchina MakGener;       // Chi ha generato il messaggio
  protected String   FrasePopUp;     // Frase da visualizzare al passaggio


  public MessSerPassami (Macchina MakGener) {
    this (MakGener, "");
  } //costruttore

  public MessSerPassami (Macchina MakGener, String FrasePopUp) {
    this.MakGener   = MakGener;
    this.FrasePopUp = FrasePopUp;
  } //costruttore

  public MessSerPassami (DataInputStream DIS) throws IOException {
    MakGener   = new Macchina (DIS);
    FrasePopUp = DIS.readUTF();
  } //costruttore


  public void scriviInStream (DataOutputStream DOS) throws IOException {
    MakGener.scriviInStream (DOS);
    DOS.writeUTF (FrasePopUp);
  } //scriviInStream


  public Macchina cheMakGener () {
    return MakGener;
  } //cheMakGener


  public String cheFrasePopUp () {
    return FrasePopUp;
  } //cheFrasePopUp


  public String toString () {
    return new String (getClass().getName()+"(MakGener="+MakGener+
                                            ",FrasePopUp="+FrasePopUp+")");
  } //toString
  
} //MessSerPassami