/**  MessSerRiaggancio (discendente di MessSer)
 *     @autore     Luigi Antenucci
 *     @versione   2.0
 *     @linguaggio jdk 1.2
 */

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;


class MessSerRiaggancio extends MessSerPassami {
  /** Messaggio Ser-->Ser per passare la richiesta di riagganciare i due vicini
   *  di un server caduto.
   */

  // Variabili d'istanza:
  protected Macchina MakCaduto;    // chi e' caduto
  // la "MakGener" e' contenuta nella superclasse


  public MessSerRiaggancio (Macchina MakCaduto, Macchina MakGener) {
    super (MakGener);
    this.MakCaduto = MakCaduto;
  } //costruttore

  public MessSerRiaggancio (DataInputStream DIS) throws IOException {
    super (DIS);
    MakCaduto = new Macchina (DIS);
  } //costruttore


  public void scriviInStream (DataOutputStream DOS) throws IOException {
    super.scriviInStream (DOS);
    MakCaduto.scriviInStream (DOS);
  } //scriviInStream


  public Macchina cheMakCaduto () {
    return MakCaduto;
  } //cheMakCaduto


  public String toString () {
    return new String (getClass().getName()+"(MakCaduto="+MakCaduto+",MakGener="+MakGener+")");
  } //toString
  
} //MessSerRiaggancio