/**  PostoZona (e' un "pannello" per l'input del posto)
 *     @autore     Luigi Antenucci
 *     @versione   2.0
 *     @linguaggio jdk 1.2
 */

import java.awt.Panel;
import java.awt.TextField;
import java.awt.Label;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;


class PostoZona extends Panel implements DatoZona {

  protected TextField  AreaFila;
  protected TextField  AreaPosi;

  public PostoZona () {
    super ();
    GridBagLayout      GBL = new GridBagLayout (); 
    GridBagConstraints GBC = new GridBagConstraints ();
    setLayout (GBL);
    setBackground (COL_SFO);
    setForeground (COL_TXT_CAMPO);

    AreaFila = new TextField (2);
    AreaPosi = new TextField (3);
    Label LabPosto = new Label ("POSTO:");
    LabPosto.setForeground(COL_TXT_NOME);
    Label LabFila  = new Label ("Fila:");
    Label LabPosi  = new Label ("Posizione:");

    GBC.anchor = GridBagConstraints.EAST;

    GBC.gridx = 0;  GBC.gridy = 0;
    GBL.setConstraints (LabPosto, GBC);
    LabPosto.setFont (FONT_NOME);
    add (LabPosto);

    GBC.gridx = 1;  GBC.gridy = 1;
    LabFila.setFont (FONT_CAMPO);
    GBL.setConstraints (LabFila, GBC);
    add (LabFila);

    GBC.gridx = 1;  GBC.gridy = 2;
    LabPosi.setFont (FONT_CAMPO);
    GBL.setConstraints (LabPosi, GBC);
    add (LabPosi);

    GBC.anchor = GridBagConstraints.WEST;

    GBC.gridx = 2;  GBC.gridy = 1;
    GBL.setConstraints (AreaFila, GBC);
    AreaFila.setFont (FONT_INPUT);
    add (AreaFila);

    GBC.gridx = 2;  GBC.gridy = 2;
    GBL.setConstraints (AreaPosi, GBC);
    AreaPosi.setFont (FONT_INPUT);
    add (AreaPosi);

  } //costruttore

  public Object rendiDati() throws Exception {
    // Occorre fare un "casting" con "Posto" dell'oggetto reso
    return new Posto ( ( AreaFila.getText() ).charAt(0),
                       (Byte.valueOf( AreaPosi.getText() )).byteValue() );
  } //rendiDati

  public void riempiDati (Object PoNuovo) {
    // L'"object" passato e' un "Posto"
    Posto PP = (Posto)PoNuovo;
    AreaFila.setText(String.valueOf (     PP.rendiFila() ));
    AreaPosi.setText(String.valueOf ((int)PP.rendiPosi() ));
  } //riempiDati

  public void cancella () {
    AreaFila.setText("");
    AreaPosi.setText("");
  } //cancella

} //PostoZona