/**  ServerDispCfg - display di configurazione per il server
 *     @autore     Luigi Antenucci
 *     @versione   2.0
 *     @linguaggio jdk 1.2
 */

import java.awt.Frame;
import java.awt.Panel;
import java.awt.Label;
import java.awt.TextField;
import java.awt.Checkbox;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Font;
import java.awt.Color;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;
import java.net.InetAddress;


//-------------- I "LISTENER" DEI BOTTONI ---------------------------------------------------------

class ListenSerCfgAn implements ActionListener {
  // Astrazione di un listener che usa un'applicazione Server e
  // la finestra di configurazione (da distruggere)
  protected Server        SerApp;   // Riferimento al Server da usare
  protected ServerDispCfg FinCfg;   // Finestra coi dati

  public ListenSerCfgAn (Server SerApp, ServerDispCfg FinCfg) { 
    this.SerApp = SerApp;
    this.FinCfg = FinCfg;
  } //costruttore

  public void actionPerformed (ActionEvent evt) {
    // Non modifica i dati del Server
    FinCfg.distruggiDisplay ();
  } //actionPerformed

} //ListenSerCfgAn


class ListenSerCfgOK extends ListenSerCfgAn implements ActionListener {

  public ListenSerCfgOK (Server SerApp, ServerDispCfg FinCfg) { 
    super (SerApp, FinCfg);
  } //costruttore

  public void actionPerformed (ActionEvent evt) {
    // MODIFICA I DATI DEL SERVER:
    String    SerInd;
    Priorita  SerPri;
    Macchina NuovaMak;
    for (byte dir=MessSer.AVANTI; dir<=MessSer.INDIETRO; dir++) {
      try {
        SerInd = FinCfg.AreaIndSer[dir].getText();
        if (SerInd.equals("")) 
          throw new Exception ("INDIRIZZO E' NULLO");

        try {
          byte PriVal = Byte.valueOf( FinCfg.AreaPriSer[dir].getText() ).byteValue();
          SerPri = new Priorita (PriVal);
        }
        catch (Exception E) { 
          throw new Exception ("PRIORITA` NON VALIDA"); 
        }

        NuovaMak = new Macchina (SerInd, SerPri);

        Macchina AttualeMak = SerApp.GestTransaz.rendiMacchinaVicina(dir);
        // Se non e' stato modificato, non faccio nulla; se no..
        if (! NuovaMak.equals(AttualeMak)) {
          // Prova a ricavarne l'indirizzo IP (se no, eccezione)
          InetAddress IPAddr = InetAddress.getByName (SerInd);

          // NB: NON MI DISCONNETTO! SPERO CHE L'UTENTE
          // SAPPIA QUELLO CHE STA FACENDO!
          // (anche se cio' e' una contraddizione)

          SerApp.GestTransaz.bloccaTransazione  (dir);
          SerApp.GestTransaz.defMacchinaVicina (dir, NuovaMak);
          SerApp.GestTransaz.abilitaTransazione (dir);
        }
      } 
      catch (Exception E) { 
        ServerDisplay Dsp = SerApp.rendiDisplay();
        Dsp.apriDialogoErrModale (Dialogo.BOTT_OK, "ERRORE", 
                                  (dir+1)+" "+E.getMessage());
      }
    } //for

    // Costanti di ritrasmissione
    String InStr;
    InStr = FinCfg.AreaTimeOutDG.getText();
    try {
    	 GestCli.TIMEOUT_GC = (Integer.valueOf(InStr).intValue()) * 1000;
      if (GestCli.TIMEOUT_GC < 1000)
        GestCli.TIMEOUT_GC=1000;
    } 
    catch (Exception E) { }

    InStr = FinCfg.AreaNumRitDG.getText();
    try {
      GestCli.MAX_TENTA_GC = Integer.valueOf(InStr).intValue();
      if (GestCli.MAX_TENTA_GC < 1)  
        GestCli.MAX_TENTA_GC=1;
    } 
    catch (Exception E) { }

    InStr = FinCfg.AreaTimeOutSS.getText();
    try {
      Protocollo.TIMEOUT_SYS = (Integer.valueOf(InStr).intValue()) * 1000;
      if (Protocollo.TIMEOUT_SYS < 1000)
        Protocollo.TIMEOUT_SYS=1000;
    } catch (Exception E) { }

    for (byte dir=MessSer.AVANTI; dir<=MessSer.INDIETRO; dir++) {
      try {
        boolean Block = FinCfg.CheckBlock[dir].getState();
        boolean OrOra = SerApp.GestTransaz.hoTransazioneBloccata(dir);
        if (Block && (! OrOra))
          SerApp.GestTransaz.bloccaTransazione (dir);
        else
          if ((! Block) && OrOra)
            SerApp.GestTransaz.abilitaTransazione (dir);
      } 
      catch (Exception E) { }
    } //for

    InStr = FinCfg.AreaPRI.getText();
    try {
      Priorita LaMiaPri = new Priorita(InStr);
      SerApp.MaMa.defPriorita (LaMiaPri);
      SerApp.IDataBase.defDefaultPriority (LaMiaPri);
    }
    catch (Exception E) { }

    InStr = FinCfg.AreaCHK.getText();
    try {
      Server.TIMEOUT_CHECK = (Integer.valueOf(InStr).intValue()) * 1000;
      if (Server.TIMEOUT_CHECK < 5000)
        Server.TIMEOUT_CHECK=5000;
    } catch (Exception E) { }
    SerApp.TimeOutCheck.ritemporizza (Server.TIMEOUT_CHECK);

    // Finestra di Debug
    SerApp.apriDebug (FinCfg.CheckDebug.getState());

    // Finestra di copyright all'avvio
    SerApp.GigiRight = FinCfg.CheckGigi.getState();

    SerApp.salvaConfig ();        // Dopo le modifiche, salvo la configurazione!

    FinCfg.distruggiDisplay ();
  } //actionPerformed

} //ListenSerCfgOK


class ListenSerCfg00 extends ListenSerCfgAn implements ActionListener {

  public ListenSerCfg00 (Server SerApp, ServerDispCfg FinCfg) { 
    super (SerApp, FinCfg);
  } //costruttore

  public void actionPerformed (ActionEvent evt) {
    SerApp.GestTransaz.azzeraTransAttive();
    FinCfg.AreaNTA.setText(Integer.toString(SerApp.GestTransaz.quanteTransAttive()));
  } //actionPerformed

} //ListenSerCfg00


//============== IL DISPLAY DI CONFIGURAZIONE =====================================================

class ServerDispCfg extends Display {
  /** Il display del programma (applicazione) Server
   */

  // Uso il pattern Model-View-Control:
  // Il server usa un display che a sua volta usa il server
  public Server MySerAp;

  public TextField[] AreaIndSer = new TextField [MessSer.INDIETRO+1];
  public TextField[] AreaPriSer = new TextField [MessSer.INDIETRO+1];
  public TextField   AreaTimeOutDG;
  public TextField   AreaNumRitDG;
  public TextField   AreaTimeOutSS;
  public Checkbox[]  CheckBlock = new Checkbox  [MessSer.INDIETRO+1];;
  public Bottone     BottAzzeraTr;
  public TextField   AreaNTA;
  public TextField   AreaPRI;
  public TextField   AreaCHK;
  public Checkbox    CheckGigi;
  public Checkbox    CheckDebug;


  public ServerDispCfg (Server MyServer) {
    this (MyServer, "");
  } //costruttore

  public ServerDispCfg (Server MyServer, String TitoloFin) {
    super (TitoloFin);
    MySerAp = MyServer;   // SALVA RIFERIMENTO A APPLICAZIONE
    CostruisciDisplay ();
    FineCostrDisplay ();
  } //costruttore

  public ServerDispCfg (Server MyServer, String TitoloFin, Frame FinPapa) {
    super (TitoloFin, FinPapa);
    MySerAp = MyServer;
    CostruisciDisplay ();
    FineCostrDisplay ();
  } //costruttore

  public ServerDispCfg (Server MyServer, Frame FinGiaCreata) {
    super (FinGiaCreata);
    MySerAp = MyServer;
    CostruisciDisplay ();
    FineCostrDisplay ();
  } //costruttore


  protected void CostruisciDisplay () {
    super.CostruisciDisplay ();

    // Riempie le caselle dei dati
    for (byte dir=MessSer.AVANTI; dir<=MessSer.INDIETRO; dir++)
      try {
        Macchina MakVic = MySerAp.GestTransaz.rendiMacchinaVicina(dir);
        AreaIndSer[dir] = new TextField (15);
        AreaPriSer[dir] = new TextField (3);
        AreaIndSer[dir].setText(MakVic.cheIndirizzo());
        AreaPriSer[dir].setText(MakVic.chePriorita().toString());
      } 
      catch (Exception E) { 
        AreaIndSer[dir].setText("???"); 
        AreaPriSer[dir].setText("?");
      }

    AreaTimeOutDG = new TextField (3);
    AreaTimeOutDG.setText(Integer.toString(GestCli.TIMEOUT_GC / 1000));

    AreaNumRitDG  = new TextField (3);
    AreaNumRitDG .setText(Integer.toString(GestCli.MAX_TENTA_GC));

    AreaTimeOutSS = new TextField (3);
    AreaTimeOutSS.setText(Integer.toString(Protocollo.TIMEOUT_SYS / 1000));

    for (byte dir=MessSer.AVANTI; dir<=MessSer.INDIETRO; dir++)
      try {
        CheckBlock[dir] = new Checkbox ();
        boolean Stato = MySerAp.GestTransaz.hoTransazioneBloccata (dir);
        CheckBlock[dir].setState (Stato);
      } 
      catch (Exception E) { }

    AreaNTA = new TextField (3);
    AreaNTA.setEditable(false);
    AreaNTA.setText(Integer.toString(MySerAp.GestTransaz.quanteTransAttive()));

    AreaPRI = new TextField (3);
    AreaPRI.setText(MySerAp.MaMa.chePriorita().toString());

    AreaCHK = new TextField (5);
    AreaCHK.setText(Integer.toString(Server.TIMEOUT_CHECK / 1000));

    CheckDebug = new Checkbox ();
    CheckDebug.setState (Debug.esisteFinestra());

    CheckGigi = new Checkbox ();
    CheckGigi.setState (MySerAp.GigiRight);

    GridBagLayout      GBL = new GridBagLayout (); 
    GridBagConstraints GBC = new GridBagConstraints ();
    setLayout(GBL);

    Label L1  = new Label ("CONFIGURAZIONE");
    L1.setFont(FONT_TEXT0);
    GBC.anchor = GridBagConstraints.CENTER;
    GBC.gridx = 1;  GBC.gridy = 1;
    GBL.setConstraints (L1, GBC);
    add (L1);

    GBC.anchor = GridBagConstraints.EAST;
    for (byte dir=MessSer.AVANTI; dir<=MessSer.INDIETRO; dir++) {
      Label L2A = new Label ("Indirizzo & Priorit del Vicino Server '"+MessSer.NOME_DIR[dir]+"':");
      GBC.gridx = 1;  GBC.gridy = 2+dir;
      GBL.setConstraints (L2A, GBC);
      add (L2A);
    }
    Label LRT = new Label ("Time-Out per Ritrasmissione Datagramma in Anello (in sec):");
    GBC.gridx = 1;  GBC.gridy = 13;
    GBL.setConstraints (LRT, GBC);
    add (LRT);
    Label LRN = new Label ("Numero Massimo di Ritrasmissioni Datagramma in Anello:");
    GBC.gridx = 1;  GBC.gridy = 14;
    GBL.setConstraints (LRN, GBC);
    add (LRN);
    Label LPT = new Label ("Time-Out per Fallimento Protocollo a Stream (in sec):");
    GBC.gridx = 1;  GBC.gridy = 15;
    GBL.setConstraints (LPT, GBC);
    add (LPT);
    for (byte dir=MessSer.AVANTI; dir<=MessSer.INDIETRO; dir++) {
      Label L2B = new Label ("Blocco delle Transazioni Datagrammi in '"+MessSer.NOME_DIR[dir]+"':");
      GBC.gridx = 1;  GBC.gridy = 16+dir;
      GBL.setConstraints (L2B, GBC);
      add (L2B);
    }
    Panel PanT = new Panel ();
    PanT.add (new Label ("Numero di Transazioni Attive:"));
    PanT.add (AreaNTA);
    PanT.add (new Label ("Azzerare?"));
    GBC.gridx = 1;  GBC.gridy = 18;
    GBL.setConstraints (PanT, GBC);
    add (PanT);

    Label LPR = new Label ("Priorit di Questo Server (per risolvere collisioni):");
    GBC.gridx = 1;  GBC.gridy = 20;
    GBL.setConstraints (LPR, GBC);
    add (LPR);

    Label LTC = new Label ("Controllo Automatico dell'Anello Ogni (tempo in sec):");
    GBC.gridx = 1;  GBC.gridy = 21;
    GBL.setConstraints (LTC, GBC);
    add (LTC);

    Label L3  = new Label ("Finestra di Debug:");
    GBC.gridx = 1;  GBC.gridy = 22;
    GBL.setConstraints (L3, GBC);
    add (L3);

    Label LGG  = new Label ("Finestra Info all'Avvio:");
    GBC.gridx = 1;  GBC.gridy = 23;
    GBL.setConstraints (LGG, GBC);
    add (LGG);
       
    GBC.anchor = GridBagConstraints.WEST;
    for (byte dir=MessSer.AVANTI; dir<=MessSer.INDIETRO; dir++) {
      GBC.gridx = 2;  GBC.gridy = 2+dir;
      GBL.setConstraints (AreaIndSer[dir], GBC);
      add(AreaIndSer[dir]);
      GBC.gridx = 3;  GBC.gridy = 2+dir;
      GBL.setConstraints (AreaPriSer[dir], GBC);
      add(AreaPriSer[dir]);
    }

    GBC.gridx = 2;  GBC.gridy = 13;
    GBL.setConstraints (AreaTimeOutDG, GBC);
    add(AreaTimeOutDG);

    GBC.gridx = 2;  GBC.gridy = 14;
    GBL.setConstraints (AreaNumRitDG, GBC);
    add(AreaNumRitDG);

    GBC.gridx = 2;  GBC.gridy = 15;
    GBL.setConstraints (AreaTimeOutSS, GBC);
    add (AreaTimeOutSS);

    for (byte dir=MessSer.AVANTI; dir<=MessSer.INDIETRO; dir++) {
      GBC.gridx = 2;  GBC.gridy = 16+dir;
      GBL.setConstraints (CheckBlock[dir], GBC);
      add(CheckBlock[dir]);
    }

    BottAzzeraTr = new Bottone ("AZZERA", Color.red, Color.white);
    BottAzzeraTr.addActionListener (new ListenSerCfg00(MySerAp, this));
    GBC.gridx = 2;  GBC.gridy = 18;
    GBL.setConstraints (BottAzzeraTr, GBC);
    add (BottAzzeraTr);

    GBC.gridx = 2;  GBC.gridy = 20;
    GBL.setConstraints (AreaPRI, GBC);
    add (AreaPRI);

    GBC.gridx = 2;  GBC.gridy = 21;
    GBL.setConstraints (AreaCHK, GBC);
    add (AreaCHK);

    GBC.gridx = 2;  GBC.gridy = 22;
    GBL.setConstraints (CheckDebug, GBC);
    add (CheckDebug);

    GBC.gridx = 2;  GBC.gridy = 23;
    GBL.setConstraints (CheckGigi, GBC);
    add (CheckGigi);

    GBC.anchor = GridBagConstraints.WEST;
    Bottone.defFont (FONT_BOTT);
    Bottone BottCfgOK  = new Bottone ("AGGIORNA", COL_SFO_BOTOK, COL_TXT_BOTOK);
    Bottone BottCfgAn  = new Bottone ("ANNULLA",  COL_SFO_BOTAN, COL_TXT_BOTAN);

    BottCfgOK.addActionListener (new ListenSerCfgOK(MySerAp, this));
    GBC.gridx = 1;  GBC.gridy = 25;
    GBL.setConstraints (BottCfgOK, GBC);
    add (BottCfgOK);

    BottCfgAn.addActionListener (new ListenSerCfgAn(MySerAp, this));
    GBC.gridx = 3;  GBC.gridy = 25;
    GBL.setConstraints (BottCfgAn, GBC);
    add (BottCfgAn);

    riposiziona (20, 70);
  } //CostruisciDisplay


  public Server rendiServer () {
    return MySerAp;
  } //rendiServer

} //ServerDispCfg