/**  ServerDispMsg - display di "passa" messaggio agli altri server
 *     @autore     Luigi Antenucci
 *     @versione   2.0
 *     @linguaggio jdk 1.2
 */

import java.awt.Frame;
import java.awt.Label;
import java.awt.TextField;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Font;
import java.awt.Color;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


//-------------- I "LISTENER" DEI BOTTONI ---------------------------------------------------------

class ListenSerMsg implements ActionListener {
  // Astrazione di un listener che usa un'applicazione Server e
  // la finestra di configurazione (da distruggere)
  protected Server        SerApp;   // Riferimento al Server da usare
  protected ServerDispMsg FinMsg;   // Finestra coi dati
  protected boolean       LeggiArea;

  public ListenSerMsg (Server SerApp, ServerDispMsg FinMsg, boolean LeggiArea) { 
    this.SerApp   = SerApp;
    this.FinMsg   = FinMsg;
    this.LeggiArea= LeggiArea;
  } //costruttore

  public void actionPerformed (ActionEvent evt) {
    // MODIFICA I DATI DEL SERVER:
    if (LeggiArea) SerApp.FrasePopUp = FinMsg.AreaNomeSer.getText();
    else           SerApp.FrasePopUp = "";
    FinMsg.distruggiDisplay ();
  } //actionPerformed

} //ListenSerMsg


//============== IL DISPLAY DI PASSAGGIO MESSAGGIO ================================================

class ServerDispMsg extends Display {
  /** Il display del programma (applicazione) Server
   */

  // Uso il pattern Model-View-Control:
  // Il server usa un display che a sua volta usa il server
  protected Server MySerAp;

  public static TextField  AreaNomeSer;


  public ServerDispMsg (Server MyServer) {
    this (MyServer, "", null);
  } //costruttore

  public ServerDispMsg (Server MyServer, String TitoloFin) {
    this (MyServer, TitoloFin, null);
  } //costruttore

  public ServerDispMsg (Server MyServer, String TitoloFin, Frame FinPapa) {
    super (TitoloFin, FinPapa);
    MySerAp = MyServer;
    CostruisciDisplay ();
    FineCostrDisplay ();
  } //costruttore

  public ServerDispMsg (Server MyServer, Frame FinGiaCreata) {
    super (FinGiaCreata);
    MySerAp = MyServer;
    CostruisciDisplay ();
    FineCostrDisplay ();
  } //costruttore


  protected void CostruisciDisplay () {
    super.CostruisciDisplay ();

    // Riempie le caselle dei dati
    AreaNomeSer = new TextField (30);

    GridBagLayout      GBL = new GridBagLayout (); 
    GridBagConstraints GBC = new GridBagConstraints ();
    setLayout(GBL);

    Label L1A = new Label ("Inserisci il Messaggio da");
    Label L1B = new Label ("Inviare agli Altri Server:");
    L1A.setFont(FONT_TEXT0);
    L1B.setFont(FONT_TEXT0);

    GBC.anchor = GridBagConstraints.CENTER;
    GBC.gridx = 2;  GBC.gridy = 1;
    GBL.setConstraints (L1A, GBC);
    add (L1A);
    GBC.gridx = 2;  GBC.gridy = 2;
    GBL.setConstraints (L1B, GBC);
    add (L1B);

    GBC.anchor = GridBagConstraints.WEST;
    GBC.gridx = 2;  GBC.gridy = 3;
    GBL.setConstraints (AreaNomeSer, GBC);
    add (AreaNomeSer);

    GBC.anchor = GridBagConstraints.WEST;
    Bottone.defFont (FONT_BOTT);
    Bottone BottCfgOK  = new Bottone ("INVIA",   COL_SFO_BOTOK, COL_TXT_BOTOK);
    Bottone BottCfgAn  = new Bottone ("ANNULLA", COL_SFO_BOTAN, COL_TXT_BOTAN);

    BottCfgOK.addActionListener (new ListenSerMsg (MySerAp, this, true));
    GBC.gridx = 1;  GBC.gridy = 4;
    GBL.setConstraints (BottCfgOK, GBC);
    add (BottCfgOK);

    BottCfgAn.addActionListener (new ListenSerMsg (MySerAp, this, false));
    GBC.gridx = 4;  GBC.gridy = 4;
    GBL.setConstraints (BottCfgAn, GBC);
    add (BottCfgAn);

    riposiziona (50, 200);

  } //CostruisciDisplay


  public Server rendiServer () {
    return MySerAp;
  } //rendiServer

} //ServerDispMsg