/**  SpettacoloZona (e' un "pannello" per l'input dello spettacolo)
 *     @autore     Luigi Antenucci
 *     @versione   2.0
 *     @linguaggio jdk 1.2
 */

import java.awt.Panel;
import java.awt.TextField;
import java.awt.Label;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;


class SpettacoloZona extends Panel implements DatoZona {

  protected TextField  AreaNome;
  protected TextField  AreaGG;
  protected TextField  AreaMM;
  protected TextField  AreaAA;
  protected TextField  AreaTurno;

  public SpettacoloZona () {
    super ();
    GridBagLayout      GBL = new GridBagLayout (); 
    GridBagConstraints GBC = new GridBagConstraints ();
    setLayout (GBL);
    setBackground (COL_SFO);
    setForeground (COL_TXT_CAMPO);

    AreaNome  = new TextField (26);
    AreaGG    = new TextField  (3);
    AreaMM    = new TextField  (3);
    AreaAA    = new TextField  (5);
    AreaTurno = new TextField  (2);
    Label LabSpett  = new Label ("SPETTACOLO:");
    LabSpett.setForeground(COL_TXT_NOME);
    Label LabNome   = new Label ("Nome:");
    Label LabData   = new Label ("Data:");
    Label LabTurno  = new Label ("Turno:");
    
    GBC.anchor = GridBagConstraints.EAST;

    GBC.gridx = 0;  GBC.gridy = 0;
    GBL.setConstraints (LabSpett, GBC);
    LabSpett.setFont (FONT_NOME);
    add (LabSpett);

    GBC.gridx = 1;  GBC.gridy = 1;
    GBL.setConstraints (LabNome, GBC);
    LabNome.setFont (FONT_CAMPO);
    add (LabNome);

    GBC.gridx = 1;  GBC.gridy = 2;
    GBL.setConstraints (LabData, GBC);
    LabData.setFont (FONT_CAMPO);
    add (LabData);

    GBC.gridx = 1;  GBC.gridy = 3;
    GBL.setConstraints (LabTurno, GBC);
    LabTurno.setFont (FONT_CAMPO);
    add (LabTurno);

    GBC.anchor = GridBagConstraints.WEST;

    GBC.gridx = 2;  GBC.gridy = 1;
    GBL.setConstraints (AreaNome, GBC);
    AreaNome.setFont (FONT_INPUT);
    add (AreaNome);

    GBC.gridx = 2;  GBC.gridy = 2;
    Panel Pan1 = new Panel ();
    AreaGG.setFont (FONT_INPUT);
    Pan1.add (AreaGG); 
    Label L1 = new Label("/");
    L1.setFont (FONT_CAMPO);
    Pan1.add (L1);
    AreaMM.setFont (FONT_INPUT);
    Pan1.add (AreaMM);
    Label L2 = new Label("/");
    L2.setFont (FONT_CAMPO);
    Pan1.add (L2);
    AreaAA.setFont (FONT_INPUT);
    Pan1.add (AreaAA);
    GBL.setConstraints (Pan1, GBC);
    add (Pan1);

    GBC.gridx = 2;  GBC.gridy = 3;
    GBL.setConstraints (AreaTurno, GBC);
    AreaTurno.setFont (FONT_INPUT);
    add (AreaTurno);
  } //costruttore

  public Object rendiDati() throws Exception {
    // Occorre fare un "casting" con "Spettacolo" dell'oggetto reso
    return new Spettacolo (AreaNome.getText(),
                           Integer.valueOf (   AreaGG.getText()).intValue(),
                           Integer.valueOf (   AreaMM.getText()).intValue(),
                           Integer.valueOf (   AreaAA.getText()).intValue(),
                           Integer.valueOf (AreaTurno.getText()).intValue() );
  } //rendiDati

  public void riempiDati (Object SpNuovo) {
    // L'"object" passato e' uno "Spettacolo"
    AreaNome .setText (                  ((Spettacolo)SpNuovo).rendiNome()    );
    AreaGG   .setText (Integer.toString( ((Spettacolo)SpNuovo).rendiGiorno() ));
    AreaMM   .setText (Integer.toString( ((Spettacolo)SpNuovo).rendiMese()   ));
    AreaAA   .setText (Integer.toString( ((Spettacolo)SpNuovo).rendiAnno()   ));
    AreaTurno.setText (Integer.toString( ((Spettacolo)SpNuovo).rendiTurno()  ));
  } //riempiDati

  public void cancella () {
    AreaNome .setText("");
    AreaGG   .setText("");
    AreaMM   .setText("");
    AreaAA   .setText("");
    AreaTurno.setText("");
  } //cancella

} //SpettacoloZona