/**  Spettatore
 *     @autore     Luigi Antenucci
 *     @versione   2.0
 *     @linguaggio jdk 1.2
 */

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.Serializable;
import java.io.IOException;


class Spettatore implements Dato, Serializable {
  /** Astrazione di uno spettatore (con tutti i suoi dati)
   */

  // Variabili d'istanza:
  protected String Nome, Cognome;

  public Spettatore (String Nome, String Cognome) {
    this.Nome=Nome;
    this.Cognome=Cognome;
  } //costruttore

  public Spettatore (DataInputStream DIS) throws IOException {
    // rende uno spettatore leggendo i dati da uno stream di byte
    Nome   =DIS.readUTF();
    Cognome=DIS.readUTF();
  } //costruttore


  public void scriviInStream (DataOutputStream DOS) throws IOException {
    // scrive su uno stream di dati i dati di uno spettatore
    DOS.writeUTF (Nome);
    DOS.writeUTF (Cognome);
  } //scriviInStream


  public String rendiNome () {
    return Nome;
  } //rendiNome

  public String rendiCognome () {
    return Cognome;
  } //rendiCognome


  public boolean corretto () {
    if ((Nome != null) && (Cognome != null))
      return (! (Nome   .equals("") || 
                 Cognome.equals("")   ) );
    else
      return false;
  } //corretto

  public String toString() {
    // Overriding del metodo definito in "Object" per rappresentazione in stringa
    return new String (Nome+"-"+Cognome);
  } //toString


  public boolean equals (Object obj) {
    // Overriding del metodo definito in "Object" per fare la ricerca nella Hashtable
    Spettatore S2 = (Spettatore)obj;
    return ( (Nome   .equals( S2.Nome)    ) &&
             (Cognome.equals( S2.Cognome) )    );
  } //equals


  public int hashCode() {
    // Overriding del metodo definito in "Object" per fare la ricerca nella Hashtable
    return toString().hashCode();
  } //hashCode

} //Spettatore