/**  SpettatoreZona (e' un "pannello" per l'input dello spettatore)
 *     @autore     Luigi Antenucci
 *     @versione   2.0
 *     @linguaggio jdk 1.2
 */

import java.awt.Panel;
import java.awt.TextField;
import java.awt.Label;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;


class SpettatoreZona extends Panel implements DatoZona {

  protected TextField  AreaNome;
  protected TextField  AreaCognome;

  public SpettatoreZona () {
    super ();
    GridBagLayout      GBL = new GridBagLayout (); 
    GridBagConstraints GBC = new GridBagConstraints ();
    setLayout (GBL);
    setBackground (COL_SFO);
    setForeground (COL_TXT_CAMPO);

    AreaNome    = new TextField (23);
    AreaCognome = new TextField (23);
    Label LabSpet    = new Label ("SPETTATORE:");
    LabSpet.setForeground(COL_TXT_NOME);
    Label LabNome    = new Label ("Nome:");
    Label LabCognome = new Label ("Cognome:");

    GBC.anchor = GridBagConstraints.EAST;

    GBC.gridx = 0;  GBC.gridy = 0;
    GBL.setConstraints (LabSpet, GBC);
    LabSpet.setFont (FONT_NOME);
    add (LabSpet);

    GBC.gridx = 1;  GBC.gridy = 1;
    GBL.setConstraints (LabNome, GBC);
    LabNome.setFont (FONT_CAMPO);
    add (LabNome);

    GBC.gridx = 1;  GBC.gridy = 2;
    GBL.setConstraints (LabCognome, GBC);
    LabCognome.setFont (FONT_CAMPO);
    add (LabCognome);

    GBC.anchor = GridBagConstraints.WEST;

    GBC.gridx = 2;  GBC.gridy = 1;
    GBL.setConstraints (AreaNome, GBC);
    AreaNome.setFont (FONT_INPUT);
    add (AreaNome);

    GBC.gridx = 2;  GBC.gridy = 2;
    GBL.setConstraints (AreaCognome, GBC);
    AreaCognome.setFont (FONT_INPUT);
    add (AreaCognome);
  } //costruttore

  public Object rendiDati() throws Exception {
    // Occorre fare un "casting" con "Spettatore" dell'oggetto reso
    return new Spettatore (    AreaNome.getText(),
                            AreaCognome.getText()  );
  } //rendiDati

  public void riempiDati (Object SpNuovo) {
    // L'"object" passato e' uno "Spettatore"
    AreaNome   .setText( ((Spettatore)SpNuovo).rendiNome()    );
    AreaCognome.setText( ((Spettatore)SpNuovo).rendiCognome() );
  } //riempiDati

  public void cancella () {
    AreaNome   .setText("");
    AreaCognome.setText("");
  } //cancella

} //SpettatoreZona