/**  TimeOutConta (vedere l'interfaccia di chi lo usa "TimeOutAvvisa")
 *     @autore     Luigi Antenucci
 *     @versione   1.0
 *     @linguaggio jdk 1.2
 */

import java.lang.Thread;


public class TimeOutConta extends Thread {
  public  static boolean  UNAVOLTA  = false;
  public  static boolean  PERSEMPRE = true;

  protected int           TimeOut;
  protected boolean       Persempre;
  protected TimeOutAvvisa ChiAvvisare;


  public TimeOutConta (int TimeOut, TimeOutAvvisa ChiAvvisare) {
    this (TimeOut, UNAVOLTA, ChiAvvisare);
  } //costruttore

  public TimeOutConta (int TimeOut, boolean Persempre, TimeOutAvvisa ChiAvvisare) {
    this.TimeOut     = TimeOut;
    this.Persempre   = Persempre;
    this.ChiAvvisare = ChiAvvisare;
  } //costruttore


  public void run() {

    do {

      eseguiAttesa();
    }
    while (Persempre);


    // "Persempre" e' modificata chimando "termina"

  } //run


  protected void eseguiAttesa () {
    boolean FuoriTempoMax;

    try {
      sleep (TimeOut);             // ATTENDE IL TIME-OUT

      FuoriTempoMax = true;        // Scaduto il time-out

    } 
    catch (InterruptedException Err) { 
      FuoriTempoMax = false;       // Uscito, SENZA arrivare al time-out
    }
  
    // Avvisa chi di dovere (invocando il metodo opportuno)
    ChiAvvisare.AvvisoDiTimeOut (FuoriTempoMax);

  } //eseguiAttesa


  public void ferma () {
    interrupt ();
  } //ferma


  public void termina () {
    Persempre = false;
    ferma ();
  } //termina


  public void ritemporizza (int TimeOut) {
    this.TimeOut = TimeOut;   // Cambia il valore del time-out
    ferma ();
  } //ritemporizza


} //TimeOutConta